<?php
/**
* @version		$Id: admin.tptop.php 
* @package		Joomla
* @subpackage	Contact
* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

/*
 * Make sure the user is authorized to view this page
 */
$user = & JFactory::getUser();

require_once( JApplicationHelper::getPath( 'admin_html' ) );

// Set the table directory
JTable::addIncludePath(JPATH_ADMINISTRATOR.DS.'components'.DS.'com_tptopitem'.DS.'tables');

$task	= JRequest::getCmd('task');
$id 	= JRequest::getVar('id', 0, 'get', 'int');
$cid 	= JRequest::getVar('cid', array(0), 'post', 'array');
JArrayHelper::toInteger($cid, array(0));

switch ($task)
{
		case 'edit':
		editCategory(true);
		break;
		
		case 'new':
		editCategory(false);
		break;
		
		case 'savecateg':	
		saveCategory($task );
		break;
		
		case 'removecateg':
		removeCategory($cid );
		break;
		
		case 'items':
		showItem( $option );
		break;
		
		case 'edititem':
		editItem(true);
		break;
		
		case 'newitem':
		editItem(false);
		break;
		
		case 'saveitem':	
		saveItem($option );
		break;
		
		case 'removeitem':
		removeItem($cid );
		break;
		
		
		case 'orderup' :
		OrderItem(-1);
		break;

		case 'orderdown' :
		OrderItem(1);
		break;
		
		case 'saveorder':
		saveOrder();
		break;
		
		default:
		showCategory( $option );
		break;
		
		
}




function showCategory( $option )
{
	global $mainframe;
	$db	= & JFactory::getDBO();
	
	$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart	= $mainframe->getUserStateFromRequest($option.'.limitstart', 'limitstart', 0, 'int');
	
	
	$query = 'SELECT COUNT(*)'.	          
			  ' FROM #__tptop_category ';
     
	$db->setQuery( $query );
	$total = $db->loadResult();
	
	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );
	
	$query = 'SELECT id,category_title,field2_title,field3_title'.
	          ' FROM  #__tptop_category ';	
	
	$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
	$rows = $db->loadObjectList();
	
	HTML_tptop_item::showCategory($rows,$pageNav,$option);
}


function editCategory($edit )
{
	$db		=& JFactory::getDBO();
	$user 	=& JFactory::getUser();

	$cid 	= JRequest::getVar('cid', array(0), '', 'array');
	$option = JRequest::getCmd('option');

	JArrayHelper::toInteger($cid, array(0));

	$row =& JTable::getInstance('category','Table');
	// load the row from the db table
	
	if($edit)
	$row->load($cid[0]);
	
	
	HTML_tptop_item::editCategory( $row, $option, $params );
}

function saveCategory($option)
{
	global $mainframe;
	
	// Check for request forgeries
	JRequest::checkToken() or jexit( 'Invalid Token' );
	
	// Initialize variables
	$db		=& JFactory::getDBO();
	$row	=& JTable::getInstance('category', 'Table');
	$post   = JRequest::get( 'post' );
	
	if (!$row->bind( $post )) {
		JError::raiseError(500, $row->getError() );
	}
	

	// pre-save checks
	if (!$row->check()) {
		JError::raiseError(500, $row->getError() );
	}

	// if new item,  last in appropriate group
	if (!$row->id) {
		$where = "id = " . (int) $row->id;		
	}

	// save the changes
	if (!$row->store()) {
		JError::raiseError(500, $row->getError() );
	}
	
	
	$row->checkin();
	
	$msg	= JText::_( 'Category saved' );
	$link	= 'index.php?option=com_tptopitem';
		
	

	$mainframe->redirect( $link, $msg );
	
}

function removeCategory(&$cid )
{
	global $mainframe;

	// Check for request forgeries
	JRequest::checkToken() or jexit( 'Invalid Token' );

	// Initialize variables
	$db =& JFactory::getDBO();
	JArrayHelper::toInteger($cid);

	if (count( $cid )) {
		$cids = implode( ',', $cid );
		$query = 'DELETE FROM #__tptop_category'
		. ' WHERE id IN ( '. $cids .' )'
		;
		$db->setQuery( $query );
		if (!$db->query()) {
			echo "<script> alert('".$db->getErrorMsg(true)."'); window.history.go(-1); </script>\n";
		}
		
		//remove related items with this category		
		$query = 'DELETE FROM #__tptop_item'
		. ' WHERE category_id IN ( '. $cids .' )'
		;
		$db->setQuery( $query );
		if (!$db->query()) {
			echo "<script> alert('".$db->getErrorMsg(true)."'); window.history.go(-1); </script>\n";
		}
		
	}

	$mainframe->redirect( "index.php?option=com_tptopitem");
}

function showItem( $option )
{
	global $mainframe;
	$db	= & JFactory::getDBO();	
	
	
	$id_categ_default = JRequest::getVar('id_categ');
	
	$context			= 'com_tptopitem.banner.list.';
	$filter_		= $mainframe->getUserStateFromRequest( $context.'filter_','filter_','cc.title',	'cmd' );
	$filter__Dir	= $mainframe->getUserStateFromRequest( $context.'filter__Dir',	'filter__Dir',	'',			'word' );
		
		
	$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
	$limitstart	= $mainframe->getUserStateFromRequest($option.'.limitstart', 'limitstart', 0, 'int');
	
	
	
	$query = 'SELECT COUNT(*)'.	          
			  ' FROM #__tptop_item';
	
	if($id_categ_default > 0){
   		$query .=" where category_id = ".$id_categ_default." ";	
   
    }	
	
	
     
	$db->setQuery( $query );
	$total = $db->loadResult();
	
	jimport('joomla.html.pagination');
	$pageNav = new JPagination( $total, $limitstart, $limit );
	
	$query = 'SELECT a.id,a.category_id,item,field2,field3,description,ordering,b.category_title'.
	          ' FROM  #__tptop_item a '.
			  ' LEFT JOIN #__tptop_category b'.
			  ' ON a.category_id = b.id' ;	
	
   if($id_categ_default > 0){
   		$query .=" where a.category_id = ".$id_categ_default." ";	
		$query  .=" order by a.ordering";
   
   }			
	
	
	$db->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
	$rows = $db->loadObjectList();
	
	
	 if($id_categ_default > 0){
   		$header =& JTable::getInstance('category','Table');
		// load the row from the db table			
		$header->load($id_categ_default);
		
   
   }	
	
	$categories[] = JHTML::_('select.option', '0', JText::_('-- Select Category -- '), 'value', 'text');
	$categories[] = JHTML::_('select.option', '-1', JText::_('-- All Categories -- '), 'value', 'text');
	$db->setQuery("SELECT id AS value, category_title AS text FROM #__tptop_category");
	$categories = array_merge($categories, $db->loadObjectList());
	$javascript = 'onchange="document.adminForm.submit();"';
	$clist = JHTML::_('select.genericlist', $categories,'id_categ', 'class="inputbox"'. $javascript,'value','text',$id_categ_default);
	
	
	
	
	HTML_tptop_item:: showItem( &$rows, &$pageNav, $option,$clist,$header);
}


function editItem($edit )
{
	$db		=& JFactory::getDBO();
	$user 	=& JFactory::getUser();

	
	
		
	$cid 	= JRequest::getVar('cid', array(0), '', 'array');
	$option = JRequest::getCmd('option');
	
	
	
	

	JArrayHelper::toInteger($cid, array(0));
	$row 	= & JTable::getInstance('item','Table');
	
	$id_default_category = 0;
	if($edit){
		$row->load($cid[0]);
		$id_default_category = $row->category_id;
	}
	
    
	$categories[] = JHTML::_('select.option', '0', JText::_('-- Select Category -- '), 'value', 'text');
	$db->setQuery("SELECT id AS value, category_title AS text FROM #__tptop_category");
	$categories   = array_merge($categories, $db->loadObjectList());
	
	$header       = JHTML::_('select.genericlist', $categories,'category_id', 'class="inputbox"','value','text',$id_default_category);	
		
	//header		
	HTML_tptop_item::editItem( $row, $option, $header);
}


function saveItem($option)
{
	global $mainframe;
	
	// Check for request forgeries
	JRequest::checkToken() or jexit( 'Invalid Token' );
	
	// Initialize variables
	$db		=& JFactory::getDBO();
	$row	=& JTable::getInstance('item', 'Table');
	$post   = JRequest::get( 'post' );
	$post['description'] = JRequest::getVar('description', '', 'post', 'string', JREQUEST_ALLOWRAW);

	
	if (!$row->bind( $post )) {
		JError::raiseError(500, $row->getError() );
	}
	

	// pre-save checks
	if (!$row->check()) {
		JError::raiseError(500, $row->getError() );
	}

	// if new item,  last in appropriate group
	if (!$row->id) {
		$where = "id = " . (int) $row->id;		
	}

	// save the changes
	if (!$row->store()) {
		JError::raiseError(500, $row->getError() );
	}
	
	
	$row->checkin();
	
	$msg	= JText::_( 'Item saved' );
	$link	= 'index.php?option=com_tptopitem&task=items';
		
	

	$mainframe->redirect( $link, $msg );
	
}


function removeItem(&$cid )
{
	global $mainframe;

	// Check for request forgeries
	JRequest::checkToken() or jexit( 'Invalid Token' );

	// Initialize variables
	$db =& JFactory::getDBO();
	JArrayHelper::toInteger($cid);

	if (count( $cid )) {
		$cids = implode( ',', $cid );
		$query = 'DELETE FROM #__tptop_item'
		. ' WHERE id IN ( '. $cids .' )'
		;
		$db->setQuery( $query );
		if (!$db->query()) {
			echo "<script> alert('".$db->getErrorMsg(true)."'); window.history.go(-1); </script>\n";
		}
	}

	$mainframe->redirect( "index.php?option=com_tptopitem&task=items");
}


function OrderItem($direction)
	{
		global $mainframe;
		$db		= & JFactory::getDBO();
		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );

		$id_categ = JRequest::getVar('id_categ');
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		if (isset( $cid[0] ))
		{
			$row = & JTable::getInstance('item', 'Table');
			$row->load( (int) $cid[0] );
			$row->move($direction,'category_id = '.(int)$row->category_id );
			print_r($row);
			
			$cache = & JFactory::getCache('com_tptopitem');
			$cache->clean();
		}		
		$mainframe->redirect('index.php?option=com_tptopitem&task=items&id_categ='.$id_categ);
	}


function saveOrder()
	{
		global $mainframe;
		$id_categ = JRequest::getVar('id_categ');
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		$db			= & JFactory::getDBO();

		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$order		= JRequest::getVar( 'order', array (0), 'post', 'array' );
		$total		= count($cid);
		$conditions	= array ();

		JArrayHelper::toInteger($cid, array(0));
		JArrayHelper::toInteger($rank, array(0));

		// Instantiate an article table object
		$row = & JTable::getInstance('item', 'Table');

		// Update the ordering for items in the cid array
		for ($i = 0; $i < $total; $i ++)
		{
			$row->load( (int) $cid[$i] );
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					JError::raiseError( 500, $db->getErrorMsg() );
					return false;
				}
				// remember to updateOrder this group
				$condition = 'caegory_id = '.(int) $row->category_id;
				$found = false;
				foreach ($conditions as $cond)
					if ($cond[1] == $condition) {
						$found = true;
						break;
					}
				if (!$found)
					$conditions[] = array ($row->id, $condition);
			}
		}

		// execute updateOrder for each group
		foreach ($conditions as $cond)
		{
			$row->load($cond[0]);
			$row->reorder($cond[1]);
		}

		$cache = & JFactory::getCache('com_tptopitem');
		$cache->clean();

		$msg = JText::_('New ordering saved');
		
		$link	= 'index.php?option=com_tptopitem&task=items&id_categ='.$id_categ;

		$mainframe->redirect( $link, $msg );
		

		
	}

?>
