<?php

/**
 * This file is a part of com_tpniceslideshow package
 * Author: http://www.templateplazza.com
 * Creator: Jerry Wijaya ( me@jerrywijaya.com )
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class TPNiceSlideShowModelItems extends JModel
{
	var $_data = null;
	var $_table = '#__tpniceslideshow_items';
	var $_list = null;
	var $_lists = null;
	var $_page = null;

	function &getTable()
	{
		if ($this->_table == null) {
			$this->_table = JTable::getInstance('items', $this->getDBO() );
		}
		return $this->_table;
	}

	function getLists() {
		global $mainframe; 
				
		$filter	= null;
		$search	= null;
		
		// Get some variables from the request
		$category			= $mainframe->getUserStateFromRequest('items.category', 'category', 0,	'int');
		$order				= $mainframe->getUserStateFromRequest('items.order', 'order', '',	'cmd');
		$order_dir	= $mainframe->getUserStateFromRequest('items.order_dir',	'order_dir',	'',	'word');
		$search				= $mainframe->getUserStateFromRequest('items.search', 'search', '',	'string');
		$search				= JString::strtolower($search);

		// get list of categories for dropdown filter
		$query = 'SELECT c.id AS value, c.title AS text' .
				' FROM #__tpniceslideshow_categories AS c';
		$lists['category'] = $this->filterCategory($query, $category);
		$lists['search'] = $search;
		$this->_lists = $lists;
		return $this->_lists;
	}

	function getList()
	{
		global $mainframe;

		if (!empty($this->_list)) {
			return $this->_list;
		}

		// Initialize variables
		$db		=& $this->getDBO();
		$filter	= null;
		$search	= null;
		
		// Get some variables from the request
		$option				= JRequest::getCmd( 'option' );
		$category			= $mainframe->getUserStateFromRequest('items.category', 'category', 0,	'int');
		$order				= $mainframe->getUserStateFromRequest('items.order', 'order', '',	'cmd');
		$order_dir	= $mainframe->getUserStateFromRequest('items.order_dir',	'order_dir',	'',	'word');
		$search				= $mainframe->getUserStateFromRequest('items.search', 'search', '',	'string');
		$search				= JString::strtolower($search);

		if (!$order OR $order<1) {
			$order = 'f.ordering';
		}
		$order = ' ORDER BY '. $order .' '. $order_dir;
		
		$where = array();

		if ($category > 0) {
			$where[] = 'f.category = '.(int) $category;
		}

		if ($search) {
			$where[] = 'LOWER( f.title_on_link ) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false ) . ' OR LOWER( f.desc_on_link ) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false ) . ' OR LOWER( f.title_on_body ) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false ) . ' OR LOWER( f.desc_on_body ) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
		}

		$where = (count($where) ? ' WHERE '.implode(' AND ', $where) : '');
		
		$limit				= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart			= $mainframe->getUserStateFromRequest('items.limitstart', 'limitstart',		0,	'int');

		// Get the total number of records
		$query = 'SELECT COUNT(*) FROM #__tpniceslideshow_items ' . $where;
		$db->setQuery($query);
		$total = $db->loadResult();

		// Create the pagination object
		jimport('joomla.html.pagination');
		$this->_page = new JPagination($total, $limitstart, $limit);

		// Get the articles
		$query = 'SELECT f.*, c.title as cname ' .
				' FROM #__tpniceslideshow_items f ' .
				' LEFT JOIN #__tpniceslideshow_categories c ON f.category=c.id ' .
				$where . 
				' GROUP BY f.id ' .
				$order;
		$db->setQuery($query, $this->_page->limitstart, $this->_page->limit);
		$this->_list = $db->loadObjectList();
		// If there is a db query error, throw a HTTP 500 and exit
		if ($db->getErrorNum()) {
			JError::raiseError( 500, $db->stderr() );
			return false;
		}

		return $this->_list;
	}

	function getPagination()
	{
		if (is_null($this->_list) || is_null($this->_page)) {
			$this->getList();
		}
		return $this->_page;
	}

	function filterCategory($query, $active = NULL)
	{
		// Initialize variables
		$db	= & JFactory::getDBO();

		$categories[] = JHTML::_('select.option', '0', '- '.JText::_('Select Category').' -');
		$db->setQuery($query);
		$categories = array_merge($categories, $db->loadObjectList());

		$category = JHTML::_('select.genericlist',  $categories, 'category', 'class="inputbox" size="1" onchange="document.adminForm.submit( );"', 'value', 'text', $active);

		return $category;
	}

}

?>
