<?php

/**
 * This file is a part of com_tpniceslideshow package
 * Author: http://www.templateplazza.com
 * Creator: Jerry Wijaya ( me@jerrywijaya.com )
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.controller' );

class TPNiceSlideShowController_items extends JController
{
	function __construct( $default = array())
	{
		parent::__construct( $default );
		$this->registerTask( 'add', 'edit' );
	}

	function display() 
  {
	   $model = &JModel::getInstance( 'TPNiceSlideShowModelItems' );
		 $table = &$model->getTable();
		
	   $view = new TPNiceSlideShowsViewItems( );
	   $view->setModel( $model, true );
	   $view->display();
  }
  
	/**
	 * display the edit form
	 * @return void
	 */
	function edit()
	{
		JRequest::setVar( 'view', 'item' );
		JRequest::setVar( 'layout', 'form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}

	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function save()
	{
		$model = $this->getModel('item');
		if ($model->store()) {
			$msg = JText::_( 'Item Saved' );
		} else {
			$msg = JText::_( 'Error Saving Item' );
		}

		// Check the table in so it can be edited.... we are done with it anyway
		$link = 'index.php?option=com_tpniceslideshow&controller=items';
		$this->setRedirect($link, $msg);
	}

	/**
	 * remove record(s)
	 * @return void
	 */
	function remove()
	{
		$model = $this->getModel('item');
		if(!$model->delete()) {
			$msg = JText::_( 'Error: Item cannot saved' );
		} else {
			$msg = JText::_( 'Item Deleted' );
		}

		$this->setRedirect( 'index.php?option=com_tpniceslideshow&controller=items', $msg );
	}

	/**
	 * cancel editing a record
	 * @return void
	 */
	function cancel()
	{
		$msg = JText::_( 'Operation Cancelled' );
		$this->setRedirect( 'index.php?option=com_tpniceslideshow&controller=items', $msg );
	}
	
	function publish() {
		$model = $this->getModel('item');
		$model->publish(1);
		$this->setRedirect( 'index.php?option=com_tpniceslideshow&controller=items', $msg );
	}
	
	function unpublish() {
		$model = $this->getModel('item');
		$model->publish(0);
		$this->setRedirect( 'index.php?option=com_tpniceslideshow&controller=items', $msg );
	}

	function orderup() {
		$cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		$model = $this->getModel('item');
		$model->orderSection( $cid[0], -1 );
		$this->setRedirect( 'index.php?option=com_tpniceslideshow&controller=items' );
	}

	function orderdown() {
		$cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		$model = $this->getModel('item');
		$model->orderSection( $cid[0], 1);
		$this->setRedirect( 'index.php?option=com_tpniceslideshow&controller=items' );
	}

	function saveorder() {
		$cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		$model = $this->getModel('item');
		$model->saveOrder( $cid );
		$msg 	= JText::_( 'New ordering saved' );
		$this->setRedirect( 'index.php?option=com_tpniceslideshow&controller=items', $msg );
	}

}
?>