<?php

/**
 * This file is a part of com_tpniceslideshow package
 * Author: http://www.templateplazza.com
 * Creator: Jerry Wijaya ( me@jerrywijaya.com )
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.application.component.model' );

class TPNiceSlideShowModelCategories extends JModel
{
	var $_data = null;
	var $_table = '#__tpniceslideshow_categories';
	var $_list = null;
	var $_page = null;

	function &getTable()
	{
		if ($this->_table == null) {
			$this->_table = JTable::getInstance('categories', $this->getDBO() );
		}
		return $this->_table;
	}

	function getList()
	{
		global $mainframe;

		if (!empty($this->_list)) {
			return $this->_list;
		}

		// Initialize variables
		$db		=& $this->getDBO();

		// Get some variables from the request
		$option				= JRequest::getCmd( 'option' );
		$limit				= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart			= $mainframe->getUserStateFromRequest('categories.limitstart', 'limitstart',		0,	'int');


		// Get the total number of records
		$query = 'SELECT COUNT(*) FROM #__tpniceslideshow_categories';
		$db->setQuery($query);
		$total = $db->loadResult();

		// Create the pagination object
		jimport('joomla.html.pagination');
		$this->_page = new JPagination($total, $limitstart, $limit);

		// Get the articles
		$query = 'SELECT c.*, count(f.id) as portfolio ' .
				' FROM #__tpniceslideshow_categories c LEFT JOIN #__tpniceslideshow_items f ON c.id=f.category ' .
				' GROUP BY c.id ORDER BY c.id';
		$db->setQuery($query, $this->_page->limitstart, $this->_page->limit);
		$this->_list = $db->loadObjectList();

		// If there is a db query error, throw a HTTP 500 and exit
		if ($db->getErrorNum()) {
			JError::raiseError( 500, $db->stderr() );
			return false;
		}

		return $this->_list;
	}

	function getPagination()
	{
		if (is_null($this->_list) || is_null($this->_page)) {
			$this->getList();
		}
		return $this->_page;
	}

}

?>
