<?php

/**
 * This file is a part of com_tpniceslideshow package
 * Author: http://www.templateplazza.com
 * Creator: Jerry Wijaya ( me@jerrywijaya.com )
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class TPNiceSlideShowModelItem extends JModel
{
	
	var $_id = null;
	var $_table = '#__tpniceslideshow_items';
	var $_lists = '#__tpniceslideshow_items';
	var $_data = null;

	function __construct()
	{
		parent::__construct();

		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);
	}

	function setId($id)
	{
		$this->_id		= $id;
	}

	function &getData()
	{
		if (empty( $this->_data )) {
			$query = ' SELECT * FROM #__tpniceslideshow_items '.
					'  WHERE id = '.$this->_id;
			$this->_db->setQuery( $query );
			$this->_data = $this->_db->loadObject();
		}
		if (!$this->_data) {
			$this->_data = new stdClass();
			$this->_data->id = 0;
			$this->_data->category = null;
			$this->_data->title_on_link = null;
			$this->_data->desc_on_link = null;
			$this->_data->title_on_body = null;
			$this->_data->desc_on_body = null;
			$this->_data->image = null;
			$this->_data->link = null;
			$this->_data->ordering = null;
			$this->_data->published = null;
		}
		return $this->_data;
	}

	function store()	{

		$row =& $this->getTable();

		$data = JRequest::get( 'post' );

		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		$file = $_FILES['imagefile'];
		if(!$row->id) {
			$uploadedImage = $this->uploadImage($row->category, $file);
			if(!$uploadedImage) {
				return false;
			} else {
				$row->image = $uploadedImage;
				$where = "category = " . $this->_db->Quote($row->category);
			}
		} else {
			if(!empty($file['name'])) {
				$uploadedImage = $this->uploadImage($row->category, $file, $row->image);
				if(!$uploadedImage) {
					return false;
				}
				$row->image = (empty($row->image))?$uploadedImage:$row->image;
			}
		}

		$db = &JFactory::getDBO();
		$where = "category = " . $this->_db->Quote($row->category);
		if(empty($row->ordering)) {
			$row->ordering = $row->getNextOrder( $where );
		} else {
			$row->ordering = $row->ordering;
		}
		$row->desc_on_body = stripslashes($_POST['desc_on_body']);
		if (!$row->store()) {
			$this->setError( JText::_('Cant Save to DB') );
			return false;
		}

		return true;
	}


	function uploadImage($category, $image, $imagename = null){
    $known_images = array('image/pjpeg', 'image/jpeg', 'image/jpg', 'image/png', 'image/x-png', 'image/gif', 'image/ico', 'image/x-icon');
		$imagename = (!empty($imagename))?$imagename:$this->getNewFileName();
    if(!empty($image['name'])){
      if($image['error'] > 0){
        switch ($image['error']){
          case UPLOAD_ERR_INI_SIZE:
            $err_msg = 'The uploaded image exceeds the upload_max_filesize directive in php.ini.';
            break;
          case UPLOAD_ERR_FORM_SIZE:
            $err_msg = 'The uploaded image exceeds the MAX_FILE_SIZE directive that was specified in the HTML form.';
            break;
          case UPLOAD_ERR_PARTIAL:
            $err_msg = 'The uploaded image was only partially uploaded.';
            break;
          case UPLOAD_ERR_NO_FILE:
            $err_msg = 'No image was uploaded.';
            break;
          case UPLOAD_ERR_NO_TMP_DIR:
            $err_msg = 'Missing a temporary folder.';
            break;
          case UPLOAD_ERR_CANT_WRITE:
            $err_msg = 'Failed to write image to disk.';
            break;
          case UPLOAD_ERR_EXTENSION:
            $err_msg = 'Image upload stopped by extension.';
            break;
          default:
            $err_msg = 'Unknown error';
            break;
        }
        if(!empty($err_msg)) {
					$this->setError($err_msg);
        	return false;
        }
      }
	      
      if(!in_array($image['type'], $known_images)){
				$this->setError(JText::_('Picture Type').': '. $image['type']. ' ' . JText::_('is unkown type!'));
      	return false;
    	}

	    if(!file_exists(JPATH_SITE . DS. 'images' . DS . 'tpniceslideshow' )) {
	    	if(!mkdir(JPATH_SITE . DS . 'images' . DS . 'tpniceslideshow')){
					$this->setError(JText::_('Failed to create tpniceslideshow directory!'));
	      	return false;
	    	}
		    JPath::setPermissions(JPATH_SITE . DS . 'images' . DS . 'tpniceslideshow', '0777');
	    }
			
			$arrImageDir = array("original", "resized", "icon");
			foreach ($arrImageDir as $imageDir) {
		    if(!file_exists(JPATH_SITE . DS. 'images' . DS . 'tpniceslideshow' . DS . $imageDir )) {
		    	if(!mkdir(JPATH_SITE . DS . 'images' . DS . 'tpniceslideshow'. DS . $imageDir)){
						$this->setError('Failed to create '.$imageDir.' directory');
		      	return false;
		    	}
			   JPath::setPermissions(JPATH_SITE . DS . 'images' . DS . 'tpniceslideshow' . DS .$imageDir, '0777');
		    }
			}
			
			$db =& JFactory::getDBO();
			$query = "SELECT * FROM #__tpniceslideshow_categories WHERE id=$category";
			$db->setQuery( $query );
			$data = $db->loadObjectList();
			$data = $data[0];
			if($image['tmp_name']) {
				foreach ($arrImageDir as $imageDir) {
					copy($image['tmp_name'], JPATH_SITE . DS . 'images' . DS . 'tpniceslideshow' . DS .$imageDir. DS .$imagename);
			    JPath::setPermissions(JPATH_SITE . DS . 'images' . DS . 'tpniceslideshow' . DS . $imageDir . DS . $imagename, '0777');
				}
				list($width, $height, $type, $attr) = getimagesize(JPATH_SITE . DS . 'images' . DS . 'tpniceslideshow' . DS . $imageDir . DS . $imagename);
				$this->resize(JPATH_SITE . DS . 'images' . DS . 'tpniceslideshow' . DS . 'original' . DS . $imagename, $width, $height);
				$this->resize(JPATH_SITE . DS . 'images' . DS . 'tpniceslideshow' . DS . 'resized' . DS . $imagename, $data->img_max_width, $data->img_max_height);
				$this->resize(JPATH_SITE . DS . 'images' . DS . 'tpniceslideshow' . DS . 'icon' . DS . $imagename, $data->thumb_max_width, $data->thumb_max_height);
				return $imagename;
			}
		}
	}

	function resize($file, $width, $height){
		$fileAtr = getimagesize($file);
		$widthOri = $fileAtr[0];
		$heightOri = $fileAtr[1];
		$type = $fileAtr['mime'];
	  $img = false;
	  switch ($type){
	    case 'image/jpeg':
	    case 'image/jpg':
	    case 'image/pjpeg':
	      $img = imagecreatefromjpeg($file);
	      break;
	    case 'image/ico':
	      $img = imagecreatefromico($file);
	      break;
	    case 'image/x-png':
	    case 'image/png':
	      $img = imagecreatefrompng($file);
	      break;
	    case 'image/gif':
	      $img = imagecreatefromgif($file);
	      break;
	  }
	  
	  if(!$img){
	    return false;
	  }
	    
	  $curr = @getimagesize($file);
	    
	  $perc_w = $width / $widthOri;
	  $perc_h = $height / $heightOri;
	  if(($widthOri<$width) && ($heightOri<$height)){
	    return;
	  }
	
	  if($perc_h > $perc_w){
	  	$width = $width;
	    $height = round($heightOri * $perc_w);
	  } else {
	    $height = $height;
	    $width = round($widthOri * $perc_h);
	  }
	
	  $nwimg = imagecreatetruecolor($width, $height);
	  imagecopyresampled($nwimg, $img, 0, 0, 0, 0, $width, $height, $widthOri, $heightOri);
	    
	  /*
	  switch ($type){
	    case 'image/jpeg':
	    case 'image/jpg':
	    case 'image/pjpeg':
	      imagejpeg($nwimg, $file);
	      break;
	    case 'image/x-png':
	    case 'image/png':
	      imagepng($nwimg, $file);
	      break;
	    case 'image/gif':
	      imagegif($nwimg, $file);
	      break;
	  }
	  */
	
	  //imagepng($nwimg, $file);
    imagejpeg($nwimg, $file, 85);
	  imagedestroy($nwimg);
	  imagedestroy($img);
	}
	
	function getNewFileName() {
		$filename = rand() . '.jpg';
		if(file_exists(JPATH_SITE . '/images/tpniceslideshow/original/' . $filename)) {
			return $this->getNewFileName();
		} else {
			return $filename;
		}
	}

	function delete()
	{
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$db =& JFactory::getDBO();
		$db->setQuery( $query );

		$row =& $this->getTable();

		if (count( $cids ))		{
			foreach($cids as $cid) {
				$db->setQuery("SELECT image FROM #__tpniceslideshow_items WHERE id=$cid");
				$image = $db->loadResult();
				if (!$row->delete( $cid )) {
					$this->setError( $row->getErrorMsg() );
					return false;
				} else {
					if(!empty($image)) {
						if(file_exists(JPATH_SITE . '/images/tpniceslideshow/original/' . $image)) {
							unlink(JPATH_SITE . '/images/tpniceslideshow/original/' . $image);
						}
						if(file_exists(JPATH_SITE . '/images/tpniceslideshow/resized/' . $image)) {
							unlink(JPATH_SITE . '/images/tpniceslideshow/resized/' . $image);
						}
						if(file_exists(JPATH_SITE . '/images/tpniceslideshow/icon/' . $image)) {
							unlink(JPATH_SITE . '/images/tpniceslideshow/icon/' . $image);
						}
					}
				}
			}						
		}
		return true;
	}

	function publish($publish) {
		$cid = JRequest::getVar( 'cid', array(0), 'post', 'array' );

		JArrayHelper::toInteger($cid);
	
		if ( count( $cid ) < 1 ) {
			$action = $publish ? 'Publish' : 'Unpublish';
			JError::raiseError(500, JText::_( 'Select Item to '.$action, true ) );
		}
		
		$cids = implode( ',', $cid );
		$count = count( $cid );
		$query = 'UPDATE #__tpniceslideshow_items'
		. ' SET published = '.(int) $publish
		. ' WHERE id IN ( '.$cids.' )'
		;

		$db =& JFactory::getDBO();
		$db->setQuery( $query );
		if (!$db->query()) {
			JError::raiseError(500, $db->getErrorMsg() );
		}
	
	}

	function orderSection( $uid, $inc, $scope )
	{
		$row =& $this->getTable();
		$row->load( $uid );
		$row->move( $inc, 'category = ' . (int) $row->category );
	}

	function saveOrder( &$cid )
	{
		$row =& $this->getTable();
	
		$total		= count( $cid );
		$order		= JRequest::getVar( 'order', array(0), 'post', 'array' );
		JArrayHelper::toInteger($order, array(0));
	
		// update ordering values
		for( $i=0; $i < $total; $i++ )
		{
			$row->load( (int) $cid[$i] );
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					JError::raiseError(500, $db->getErrorMsg() );
				}
			}
		}
	
		$row->reorder();
	}
	
	function getLists() {
		global $mainframe; 
				
		$category	= $this->_data->category;

		$query = 'SELECT c.id AS value, c.title AS text' .
				' FROM #__tpniceslideshow_categories AS c';
		$lists['category'] = $this->filterCategory($query, $category);
		$this->_lists = $lists;
		return $this->_lists;
	}

	function filterCategory($query, $active = NULL)
	{
		// Initialize variables
		$db	= & JFactory::getDBO();

		$categories[] = JHTML::_('select.option', '0', '- '.JText::_('Select Category').' -');
		$db->setQuery($query);
		$categories = array_merge($categories, $db->loadObjectList());

		$category = JHTML::_('select.genericlist',  $categories, 'category', 'class="inputbox" size="1"', 'value', 'text', $active);

		return $category;
	}

}

?>