<?

/**
* Copyright (C) 2008 TemplatePlazza.com
* This file is part of the TPNiceSlideShow Component for Joomla 1.0.x,
* a Joomla! TPNiceSlideShow Component by TemplatePlazza.com
* Author: Jerry Wijaya (me@jerrywijaya.com)
* Email: info@templateplazza.com
*/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

class dbTPNiceSlideShowCategories extends mosDBTable {
	var $id = null;
	var $title = null;
	var $img_max_width = null;
	var $img_max_height = null;
	var $thumb_max_width = null;
	var $thumb_max_height = null;

	function dbTPNiceSlideShowCategories() {
		global $database;
		$this->mosDBTable( '#__tpniceslideshow_categories', 'id', $database );
	}
}

class dbTPNiceSlideShowItems extends mosDBTable {
	var $id = null;
	var $category = null;
	var $title_on_link = null;
	var $desc_on_link = null;
	var $title_on_body = null;
	var $desc_on_body = null;
	var $image = null;
	var $link = null;
	var $published = null;
	var $ordering = null;

	function dbTPNiceSlideShowItems() {
		global $database;
		$this->mosDBTable( '#__tpniceslideshow_items', 'id', $database );
	}
}

class TPNiceSlideShowCategories {
	
	function edit($cid) {
    global $database;
    $row = new dbTPNiceSlideShowCategories($database);
    $row->load($cid);	    
	  HTML_TPNICESLIDESHOWCATEGORIES::edit($row);
	}
	
	function show() {
    global $database, $mainframe, $option;
    
  	$limit = intval( $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', $mainframe->getCfg('list_limit') ) );
  	$limitstart	= intval( $mainframe->getUserStateFromRequest( "view{$option}limitstart", 'limitstart', 0 ) );
  	
  	$basequery = "SELECT COUNT(*) FROM #__tpniceslideshow_categories";
  	$database->setQuery($basequery);
  	$total = $database->loadResult();
  	
  	require_once($mainframe->getCfg('absolute_path') . '/administrator/includes/pageNavigation.php');
  	$pageNav = new mosPageNav($total, $limitstart, $limit);
  	
  	$query = "SELECT c.*, count(f.id) as fcount FROM #__tpniceslideshow_categories c LEFT JOIN #__tpniceslideshow_items f ON c.id=f.category GROUP BY c.id ORDER BY c.id ASC LIMIT " . $limitstart . ", " . $limit;
  	$database->setQuery($query);
  	$rows = $database->loadObjectList();
  	echo $database->getErrorMsg();

  	HTML_TPNICESLIDESHOWCATEGORIES::show($rows, $pageNav);
	}
	
	function save($task = null) {
		global $option;

		$data = $_POST;
					
		$row = new dbTPNiceSlideShowCategories;
		$row->bind($data);
		if (!$row->check()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}
										
		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		if($task == 'save') {
			mosRedirect( 'index2.php?option='. $option .'&act=categories' );
		} else {
			mosRedirect( 'index2.php?option='. $option .'&act=categories&task=edit&hidemainmenu=1&cid=' . $row->id );
		}
	}	

	function remove($cid) {
		global $database, $option, $mainframe;
	
		$total = count( $cid );
		if ( $total < 1) {
			echo "<script> alert('Select an item to delete'); window.history.go(-1);</script>\n";
			exit;
		}
	
		mosArrayToInts( $cid );

		$total = 0;
		foreach($cid as $id) {
			$database->setQuery("SELECT count(*) FROM #__tpniceslideshow_items WHERE category=".$id);
			if(!$database->loadResult()) {
				$database->setQuery("DELETE FROM #__tpniceslideshow_categories WHERE id=" . $id);
				$database->setQuery( $query );
				if ( !$database->query() ) {
					echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
					exit();
				} else {
					$total++;
				}
			}
		}
		
		$msg = $total ." Item(s) deleted successfully";
		mosRedirect( 'index2.php?option='. $option .'&act=categories', $msg );
	}
}

class TPNiceSlideShowItems {
	
	function edit($cid) {
    global $database;
    $row = new dbTPNiceSlideShowItems($database);
    $row->load($cid);

		// build the html select list for ordering
		$query = "SELECT id AS value, title AS text"
		. "\n FROM #__tpniceslideshow_categories"
		. "\n ORDER BY id"
		;
		$database->setQuery($query);
		$categoryid[] = mosHTML::makeOption( -1 , '- Select Category -' );
		$categoryid = array_merge($categoryid, $database->loadObjectList());
		$lists['category'] = mosHTML::selectList( $categoryid, 'category', 'class="inputbox" size="1"', 'value', 'text', intval( $row->category ) );
	    
	  HTML_TPNICESLIDESHOWITEMS::edit($row, $lists);
	}
	
	function show() {
    global $database, $mainframe, $option;
    
   	$limit = intval( $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', $mainframe->getCfg('list_limit') ) );
  	$limitstart	= intval( $mainframe->getUserStateFromRequest( "view{$option}limitstart", 'limitstart', 0 ) );
  	$category	= intval( $mainframe->getUserStateFromRequest( "view{$option}category", 'category', -1 ) );
  	$search	= strval( $mainframe->getUserStateFromRequest( "view{$option}search", 'search', '' ) );

		$where = array();

		if ($category > 0) {
			$where[] = 'i.category = '.(int) $category;
		}

		if (isset($search)) {
			if(strlen($search)>=1) {
				$where[] = 'LOWER( i.title_on_link ) LIKE '.$database->Quote( '%'.$database->getEscaped( $search, true ).'%', false ) . ' OR LOWER( i.desc_on_link ) LIKE '.$database->Quote( '%'.$database->getEscaped( $search, true ).'%', false ) . ' OR LOWER( i.title_on_body ) LIKE '.$database->Quote( '%'.$database->getEscaped( $search, true ).'%', false ) . ' OR LOWER( i.desc_on_body ) LIKE '.$database->Quote( '%'.$database->getEscaped( $search, true ).'%', false );
			}
		}

		$where = (count($where) ? ' WHERE '.implode(' AND ', $where) : '');
 	
  	$basequery = "SELECT COUNT(*) FROM #__tpniceslideshow_items" . $where;
  	$database->setQuery($basequery);
  	$total = $database->loadResult();
  	
  	require_once($mainframe->getCfg('absolute_path') . '/administrator/includes/pageNavigation.php');
  	$pageNav = new mosPageNav($total, $limitstart, $limit);
  	
  	$query = "SELECT i.*, f.title as categoryName FROM #__tpniceslideshow_items i LEFT JOIN #__tpniceslideshow_categories f ON i.category=f.id " . $where . " ORDER BY i.ordering ASC LIMIT " . $limitstart . ", " . $limit;
  	$database->setQuery($query);
  	$rows = $database->loadObjectList();
  	echo $database->getErrorMsg();

		$query = "SELECT id AS value, title AS text"
		. "\n FROM #__tpniceslideshow_categories"
		. "\n ORDER BY id"
		;

		$database->setQuery($query);
		$categories[] = mosHTML::makeOption( -1 , '- Select Category -' );
		$categories = array_merge($categories, $database->loadObjectList());
		$lists['category'] = mosHTML::selectList( $categories, 'category', 'class="inputbox" size="1"  onchange="document.adminForm.submit();"', 'value', 'text', intval( $category ) );
		$lists['search'] = $search;
		
  	HTML_TPNICESLIDESHOWITEMS::show($rows, $pageNav, $lists);
	}
	
	function save($task = null) {
		global $option, $database;

		$data = $_POST;
					
		$row = new dbTPNiceSlideShowItems;
		$row->bind($data);
		if (!$row->check()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		$file = $_FILES['imagefile'];

		$database->setQuery("SELECT * FROM #__tpniceslideshow_categories WHERE id='".$row->category."'");

		$catData = null;
		$database->loadObject($catData);

		$img_max_width = $catData->img_max_width;
		$img_max_height = $catData->img_max_height;
		$thumb_max_width = $catData->thumb_max_width;
		$thumb_max_height = $catData->thumb_max_height;
		
		if(!$row->id) {
			$uploadedImage = TPNiceSlideShowItems::uploadImage($file, $img_max_width, $img_max_height, $thumb_max_width, $thumb_max_height);
			if(!$uploadedImage) {
				mosRedirect( 'index2.php?option='. $option .'&act=items' );
			} else {
				$row->image = $uploadedImage;
				$where = "category = " . $database->Quote($row->category);
			}
		} else {
			if(!empty($file['name'])) {
				$uploadedImage = TPNiceSlideShowItems::uploadImage($file, $img_max_width, $img_max_height, $thumb_max_width, $thumb_max_height, $row->image);
				if(!$uploadedImage) {
					mosRedirect( 'index2.php?option='. $option .'&act=items' );
				}
				$row->name = (empty($row->image))?$uploadedImage:$row->image;
			}
		}
										
		if (!$row->store()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			exit();
		}

		$row->updateOrder('category='.$row->category);
					
		if($task == 'save') {
			mosRedirect( 'index2.php?option='. $option .'&act=items' );
		} else {
			mosRedirect( 'index2.php?option='. $option .'&act=items&task=edit&hidemainmenu=1&cid=' . $row->id );
		}
	}	

	function uploadImage($image, $img_max_width, $img_max_height, $thumb_max_width, $thumb_max_height, $imagename = null){
		global $mainframe;
    $known_images = array('image/pjpeg', 'image/jpeg', 'image/jpg', 'image/png', 'image/x-png', 'image/gif', 'image/ico', 'image/x-icon');
		$imagename = (!empty($imagename))?$imagename:TPNiceSlideShowItems::getNewFileName();
		
    if(!empty($image['name'])){
      if($image['error'] > 0){
        switch ($image['error']){
          case UPLOAD_ERR_INI_SIZE:
            $err_msg = 'The uploaded image exceeds the upload_max_filesize directive in php.ini.';
            break;
          case UPLOAD_ERR_FORM_SIZE:
            $err_msg = 'The uploaded image exceeds the MAX_FILE_SIZE directive that was specified in the HTML form.';
            break;
          case UPLOAD_ERR_PARTIAL:
            $err_msg = 'The uploaded image was only partially uploaded.';
            break;
          case UPLOAD_ERR_NO_FILE:
            $err_msg = 'No image was uploaded.';
            break;
          case UPLOAD_ERR_NO_TMP_DIR:
            $err_msg = 'Missing a temporary folder.';
            break;
          case UPLOAD_ERR_CANT_WRITE:
            $err_msg = 'Failed to write image to disk.';
            break;
          case UPLOAD_ERR_EXTENSION:
            $err_msg = 'Image upload stopped by extension.';
            break;
          default:
            $err_msg = 'Unknown error';
            break;
        }
        if(!empty($err_msg)) {
					echo "<script> alert('".$err_msg."'); window.history.go(-1); </script>\n";
        	return false;
        }
      }
	      
      if(!in_array($image['type'], $known_images)){
				echo "<script> alert('Picture type: ". $image['type']. " is unkown type.'); window.history.go(-1); </script>\n";
      	return false;
    	}

	    if(!file_exists($mainframe->getCfg('absolute_path') . '/images/tpniceslideshow' )) {
	    	if(!mkdir($mainframe->getCfg('absolute_path') . '/images/tpniceslideshow')){
					echo "<script> alert('Failed to create tpniceslideshow directory!'); window.history.go(-1); </script>\n";
	      	return false;
	    	}
		    mosChmod($mainframe->getCfg('absolute_path') . '/images/tpniceslideshow', 0777);
	    }
			
			$arrImageDir = array("original", "resized", "icon");
			foreach ($arrImageDir as $imageDir) {
		    if(!file_exists($mainframe->getCfg('absolute_path') . '/images/tpniceslideshow/' . $imageDir )) {
		    	if(!mkdir($mainframe->getCfg('absolute_path') . '/images/tpniceslideshow/' . $imageDir)){
						echo "<script> alert('Failed to create '.$imageDir.' directory'); window.history.go(-1); </script>\n";
		      	return false;
		    	}
			    mosChmod($mainframe->getCfg('absolute_path') . '/images/tpniceslideshow/' . $imageDir, 0777);
		    }
			}

			if($image['tmp_name']) {
				foreach ($arrImageDir as $imageDir) {
					copy($image['tmp_name'], $mainframe->getCfg('absolute_path') . '/images/tpniceslideshow/' . $imageDir . '/' . $imagename);
			    mosChmod($mainframe->getCfg('absolute_path') . '/images/tpniceslideshow/' . $imageDir . '/' . $imagename, 0777);
				}
				list($width, $height, $type, $attr) = getimagesize($mainframe->getCfg('absolute_path') . '/images/tpniceslideshow/' . $imageDir . '/' . $imagename);
				TPNiceSlideShowItems::resize($mainframe->getCfg('absolute_path') . '/images/tpniceslideshow/original/' . $imagename, $width, $height);

				TPNiceSlideShowItems::resize($mainframe->getCfg('absolute_path') . '/images/tpniceslideshow/resized/' . $imagename, $img_max_width, $img_max_height);
				TPNiceSlideShowItems::resize($mainframe->getCfg('absolute_path') . '/images/tpniceslideshow/icon/' . $imagename, $thumb_max_width, $thumb_max_height);
				return $imagename;
			}
		}
	}

	function resize($file, $width, $height){
		$fileAtr = getimagesize($file);
		$widthOri = $fileAtr[0];
		$heightOri = $fileAtr[1];
		$type = $fileAtr['mime'];
	  $img = false;
	  switch ($type){
	    case 'image/jpeg':
	    case 'image/jpg':
	    case 'image/pjpeg':
	      $img = imagecreatefromjpeg($file);
	      break;
	    case 'image/ico':
	      $img = imagecreatefromico($file);
	      break;
	    case 'image/x-png':
	    case 'image/png':
	      $img = imagecreatefrompng($file);
	      break;
	    case 'image/gif':
	      $img = imagecreatefromgif($file);
	      break;
	  }
	  
	  if(!$img){
	    return false;
	  }
	    
	  $curr = @getimagesize($file);
	    
	  $perc_w = $width / $widthOri;
	  $perc_h = $height / $heightOri;
	  if(($widthOri<$width) && ($heightOri<$height)){
	    return;
	  }
	
	  if($perc_h > $perc_w){
	  	$width = $width;
	    $height = round($heightOri * $perc_w);
	  } else {
	    $height = $height;
	    $width = round($widthOri * $perc_h);
	  }
	
	  $nwimg = imagecreatetruecolor($width, $height);
	  imagecopyresampled($nwimg, $img, 0, 0, 0, 0, $width, $height, $widthOri, $heightOri);
	    
	  imagejpeg($nwimg, $file);
	  imagedestroy($nwimg);
	  imagedestroy($img);
	}
	
	function getNewFileName() {
		global $mosConfig_absolute_path;
		$filename = rand() . '.jpg';
		if(file_exists($mosConfig_absolute_path . '/images/tpniceslideshow/original/' . $filename)) {
			return TPNiceSlideShowItems::getNewFileName();
		} else {
			return $filename;
		}
	}

	function remove($cid) {
		global $database, $option, $mainframe;
	
		$total = count( $cid );
		if ( $total < 1) {
			echo "<script> alert('Select an item to delete'); window.history.go(-1);</script>\n";
			exit;
		}
	
		mosArrayToInts( $cid );
		$arrImageDir = array("original", "resized", "icon");
		foreach($cid as $iid) {
			$database->setQuery("SELECT image FROM #__tpniceslideshow_items WHERE id=".$iid);
			$filename = $database->loadResult();
			foreach ($arrImageDir as $imageDir) {
		    if(file_exists($mainframe->getCfg('absolute_path') . '/images/tpniceslideshow/' . $imageDir . '/' . $filename )) {
			    mosChmod($mainframe->getCfg('absolute_path') . '/images/tpniceslideshow/' . $imageDir . '/' . $filename, 0777);
			    unlink($mainframe->getCfg('absolute_path') . '/images/tpniceslideshow/' . $imageDir . '/' . $filename);
		    }
			}
		}

		$cids = 'id=' . implode( ' OR id=', $cid );
		$query = "DELETE FROM #__tpniceslideshow_items"
		. "\n WHERE $cids"
		;
		$database->setQuery( $query );
		if ( !$database->query() ) {
			echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
			exit();
		}

		$msg 	= $total ." Item(s) deleted successfully";
		mosRedirect( 'index2.php?option='. $option .'&act=items', $msg );
	}
	
	function publish($cid = null, $state = null) {
		global $database, $my, $task, $option;
		
		if (count( $cid ) < 1) {
			$action = $state == 1 ? 'publish' : 'unpublish';
			echo "<script> alert('Select an item to $action'); window.history.go(-1);</script>\n";
			exit;
		}
	
		mosArrayToInts( $cid );
		$total = count ( $cid );
		$cids = 'id=' . implode( ' OR id=', $cid );
	
		$query = "UPDATE #__tpniceslideshow_items"
		. "\n SET published = " . (int) $state
		. "\n WHERE $cids"
		;
		$database->setQuery( $query );
		if (!$database->query()) {
			echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
			exit();
		}
		switch ( $state ) {
			case 1:
				$msg = $total .' Item(s) successfully Published';
				break;
			case 0:
			default:
				$msg = $total .' Item(s) successfully Unpublished';
				break;
		}
		mosRedirect( 'index2.php?option='. $option .'&act=items&mosmsg='. $msg );
	}

	function order( $id, $inc ) {
		global $option;
	
		$row = new dbTPNiceSlideShowItems();
		$row->load( (int)$id );
		$row->move( $inc, 'category='.$row->category );

		mosRedirect( 'index2.php?option='. $option .'&act=items' );
	}

	function saveOrder( &$cid ) {
		global $option;
		
		$total		= count( $cid );
		$order 		= josGetArrayInts( 'order' );
		
		$row 				= new dbTPNiceSlideShowItems();
		$conditions = array();
	
		for( $i=0; $i < $total; $i++ ) {
			$row->load( (int) $cid[$i] );
			$row->updateOrder( 'category='.$row->category );
			echo '';
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1); </script>\n";
					exit();
				}
			}
		}
	
		$msg 	= 'New ordering saved';
		mosRedirect( 'index2.php?option='.$option.'&act=folioid', $msg );
	}

}

?>